﻿601,100
602,"IBM.Dim.Update.Date"
562,"NULL"
586,
585,
564,
565,"ok6_1fHm>=uip1kaCW[N70>iUmYY_Z?WBpw>dAi_R8NAi8mqDbwaRQMQPMnpJ7WAxB1wW;S6_>MeTZp@dYag<JfqU=MG6WCQsG0QPUEhxCQ4d0E?CFj^:@IJC;VP1OYmITNuSJw7qO2zs]]SUIAS;VKzePOHq2@apAhlzTeMZ3thG\g@8i@\vjq=I\p_>0:L`q`Kiv]e"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,","
568,""""
570,
571,
569,0
592,0
599,1000
560,3
pDim
pStartYear
pEndYear
561,3
2
1
1
590,3
pDim,""
pStartYear,0
pEndYear,0
637,3
pDim,"Enter dimension name"
pStartYear,"Enter start year"
pEndYear,"Enter end year"
577,0
578,0
579,0
580,0
581,0
582,0
603,0
572,134
#****Begin: Generated Statements***
#****End: Generated Statements****

#===========================================================================================
# Purpose:        This process will build a continuous time dimension based on the range of years 
#
# Info:                   You can create years between 1900 & 3000 by default but this can be modified by changing the 
#                            numeric variables nYrRangeStart and nYrRangeEnd
#                            Four standard attributes will be created:
#                            Next Period, Prior Period, Next Year Period, Prior Year Period
#                            The ItemReject function displays on screen if executed in Planning Analytics Workspace (PAW) 
#
# Parameters:    pDim = Enter name of dimension to build ( Cannot be blank )
#                             pStartYear = Enter start year ( Must be greater than variable nYrRangeStart )
#                             pEndYear = Enter end year ( Must be less than variable nYrRangeEnd )
#
#===========================================================================================

## Name variables 
nYrRangeStart = 1900;
nYrRangeEnd = 3000;


## Validate parameters

# Check if dim name is blank
If ( Trim ( pDim )  @='' );
  sMsg = 'Please enter a valid dimension name';
  ItemReject ( sMsg );
EndIf;

# Check if start and end year are between variable ranges
If ( pStartYear < nYrRangeStart % pStartYear > nYrRangeEnd-1 );
  sMsg = 'Please enter a start year between ' | NumberToString ( nYrRangeStart ) | ' and ' | NumberToString ( nYrRangeEnd -1 );
  ItemReject ( sMsg );
EndIf;

# Check if end year is not outside of end year variable    
If ( pEndYear > 3000 );
  sMsg = 'Please enter an end year less than ' | NumberToString ( nYrRangeEnd );
  ItemReject ( sMsg );
EndIf;

# Check if end year is less than start year
If ( pEndYear < pStartYear );
  sMsg = 'Start year cannot be greater than End year';
  ItemReject ( sMsg );
Endif;


## Create dimension
If ( DimensionExists ( pDim ) = 0 );
  DimensionCreate ( pDim );
Endif;


## Insert top level node
sTopNode = 'All ' | pDim;
DimensionElementInsertDirect ( pDim, '', sTopNode, 'C' );


## Insert range of years into dimension
nYearIndex = pStartYear;
nYearLimit = pEndYear;

  While ( nYearIndex <= nYearLimit );
    sYear = NumberToString ( nYearIndex );
    DimensionElementComponentAddDirect ( pDim, sTopNode, sYear, 1 );

    # Insert Quarter and Months to dimension 
    nMthIndex = 1;
    nMthLimit = 12;

      While ( nMthIndex <= nMthLimit );

        If ( nMthIndex <= 3 );
          nQtrIndex = 1;
        ElseIf ( nMthIndex > 3 & nMthIndex <= 6 );
          nQtrIndex = 2;
        ElseIf ( nMthIndex > 6 & nMthIndex <= 9 );
          nQtrIndex = 3;
        ElseIf ( nMthIndex > 9 & nMthIndex <=12 );
          nQtrIndex = 4;
        EndIf;

    sMth = NumberToString ( nMthIndex ) | '-' | sYear;
    sQtr = 'Q' | NumberToString ( nQtrIndex ) | '-' | sYear;

      DimensionElementComponentAddDirect ( pDim, sYear, sQtr, 1 );     
      DimensionElementComponentAddDirect ( pDim, sQtr, sMth, 1 );

    nMthIndex = nMthIndex +1;
  End;

  nYearIndex = nYearIndex +1;
End;


## Insert Attributes if they don't exist

# Next Period
sAttrName = 'Next Period';
sAttrType = 'S';
If ( DimIx ( '}ElementAttributes_' | pDim, sAttrName ) = 0 );
  AttrInsert ( pDim,'', sAttrName, sAttrType );
EndIf;

# Prior Period
sAttrName = 'Prior Period';
sAttrType = 'S';
If ( DimIx ( '}ElementAttributes_' | pDim, sAttrName ) = 0 );
  AttrInsert ( pDim,'', sAttrName, sAttrType );
EndIf;

# Next Year Period
sAttrName = 'Next Year Period';
sAttrType = 'S';
If ( DimIx ( '}ElementAttributes_' | pDim, sAttrName ) = 0 );
  AttrInsert ( pDim,'', sAttrName, sAttrType );
EndIf;

# Prior Year Period
sAttrName = 'Prior Year Period';
sAttrType = 'S';
If ( DimIx ( '}ElementAttributes_' | pDim, sAttrName ) = 0 );
  AttrInsert ( pDim,'', sAttrName, sAttrType );
EndIf;


## Sort Dimension
DimensionSortOrder ( pDim, 'ByName','Ascending','ByHierarchy' , 'Ascending' );



573,1

574,1

575,66
#****Begin: Generated Statements***
#****End: Generated Statements****


## Name variables 
nYearIndex = pStartYear;
nYearLimit = pEndYear;


  # Create Next Period, Prior Period, Next Year Period and Prior Year Period attributes
  While ( nYearIndex <= nYearLimit );
    nYr = nYearIndex;
    nNextYr = nYearIndex +1;
    nPriorYr = nYearIndex -1;
    sYr = NumberToString ( nYr );
    sNextYr = NumberToString ( nNextYr );
    sPriorYr = NumberToString ( nPriorYr );

    nIndex=1;
    nLimit=12;

    While ( nIndex<=nLimit );

      # Insert Next Period Attributes
      If ( nIndex <=11 );
        sNextMth = NumberToString ( nIndex +1 ) | '-' | sYr;
        AttrPutS ( sNextMth, pDim, NumberToString ( nIndex ) |'-'| sYr,  'Next Period');
      EndIf;

      If ( nIndex =12 );
        sNextMth = '1' | '-' | sNextYr;
        AttrPutS ( sNextMth, pDim, '12' |'-'| sYr,  'Next Period');
      EndIf;


      # Insert Prior Period Attributes
      If ( nIndex =1 );
        sPriorMth = '12' | '-' | sPriorYr;
        If ( DimIx ( pDim, sPriorYr ) > 0 );
          AttrPutS ( sPriorMth, pDim, '1' |'-'| sYr,  'Prior Period');
        Endif;
      EndIf;

      If ( nIndex >1 );
        sPriorMth = NumberToString ( nIndex -1 ) | '-' | sYr;
        AttrPutS ( sPriorMth, pDim, NumberToString ( nIndex ) |'-'| sYr,  'Prior Period');
      EndIf;

      # Insert Next Year Period Attributes
        sNextYrPeriod = NumberToString ( nIndex ) | '-' | sNextYr;
        If ( DimIx ( pDim, sNextYr ) > 0 );
          AttrPutS ( sNextYrPeriod, pDim, NumberToString ( nIndex ) |'-'| sYr,  'Next Year Period');
        Endif;

      # Insert Prior Year Period Attributes
        sPriorYrPeriod = NumberToString ( nIndex ) | '-' | sPriorYr;
        If ( DimIx ( pDim, sPriorYr ) > 0 );
          AttrPutS ( sPriorYrPeriod, pDim, NumberToString ( nIndex ) |'-'| sYr,  'Prior Year Period');
        Endif;

    nIndex= nIndex +1;
    End;

  nYearIndex = nYearIndex +1;
End;

576,_ParameterConstraints=e30=
930,0
638,1
804,0
1217,0
900,
901,
902,
938,0
937,
936,
935,
934,
932,0
933,0
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
