﻿601,100
602,"IBM.Subset.Create.DrillDown.Member.ByLevel (5)"
562,"NULL"
586,
585,
564,
565,"eyA5daa[=nr5b8FCEyS;?rsRG=9]6=e1:DPzfseSteSr_C>`>\tvmxvzO61v<k>9mdHs9:YYk]ICVu7VcBMJ2`oDe3nVC0HKbQEERTIYCHi\Bb0Qlpx6vAMpaXUnxe@CJ7m1K9U>El@REyA3HFBjpU9rBvoyagV;xB^K;`DEFGs=E4C>Koh6Em1@GtG_vh2<8iilURfN"
559,1
928,0
593,
594,
595,
597,
598,
596,
800,
801,
566,0
567,","
588,"."
589,","
568,""""
570,
571,
569,0
592,0
599,1000
560,5
pDim
pConsolElement
pLevel
pSub
pAlias
561,5
2
2
1
2
2
590,5
pDim,""
pConsolElement,""
pLevel,0
pSub,""
pAlias,""
637,5
pDim,"Enter existing dimension name"
pConsolElement,"Enter consolidated element to filter and drill down"
pLevel,"Enter level to filter by"
pSub,"Enter subset name"
pAlias,"Enter alias to set (Optional)"
577,0
578,0
579,0
580,0
581,0
582,0
603,0
572,108
#****Begin: Generated Statements***
#****End: Generated Statements****

#===========================================================================================
# Purpose:        This process will create a dynamic subset based on a valid dimension and element name
#
# Info:                   The MDX expression TM1FilterByLevel({TM1DrillDownMember returns:
#                             a specified level of a named parent – i.e. the hierarchy down to the leaf level
#
# Parameters:    pDim = Enter name of dimension to create subset in ( Must be an existing dimension )
#                             pConsolElement = Enter name of a consolidated element to drilldown on and filter ( Must be an existing consolidated element )
#                             pLevel = Filter the element at a specific level ( i.e. 0 or 1 )
#                             pSub = Enter name of subset to create ( Cannot be blank )
#                             pAlias = Enter name of an alias to display for subset ( Optional but must be an existing alias )
#
#===========================================================================================

## Validate parameters

# Validate if dimension exists
If ( DimensionExists ( Trim ( pDim ) ) = 0 );
  sMsg = 'Dimension does not exist. Please enter a valid dimension name';
  ItemReject ( sMsg );
EndIf;

# Validate if pConsolElement is a consolidated element
If ( ElLev ( pDim, pConsolElement ) = 0 );
  sMsg = 'Consolidated element entered is a leaf element. Please enter a consolidated element';
  ItemReject ( sMsg );
EndIf;

# Validate if consolidated element exists in dimension
If ( DimIx ( pDim, Trim ( pConsolElement ) ) = 0 );
  sMsg = 'Consolidated element does not exist. Please enter a valid consolidated element';
  ItemReject ( sMsg );
EndIf;

# Validate if level exists in dimension
If ( pLevel > DnLev ( pDim ) );
  sMsg = 'Level does not exist in the dimension';
  ItemReject ( sMsg );
EndIf;

# Validate if level entered is less than level of consolidated element
If ( pLevel >= ElLev ( pDim, pConsolElement ) );
  sMsg = 'Input a level number that is less than the consolidated element level';
  ItemReject ( sMsg );
EndIf;

# Validate if level is less than zero
If ( pLevel < 0 );
  sMsg = 'Level cannot be less than 0';
  ItemReject ( sMsg );
EndIf;

# Validate if level entered is a whole number
If ( Scan ( '.', NumberToString ( pLevel ) ) > 0 );
  sMsg = 'Enter level as a whole number';
  ItemReject ( sMsg );
EndIf;

# Validate if subset name is blank
If ( Trim ( pSub )  @='' );
  sMsg = 'Subset name cannot be blank. Please enter a valid subset name';
  ItemReject ( sMsg );
EndIf;

# Validate if attribute dimension exsits
If ( pAlias @<> '' );
  sDimAttr = '}ElementAttributes_' | pDim;
  If ( DimensionExists ( sDimAttr ) = 0 );
    sMsg = 'No attributes exist for the dimension';
    ItemReject ( sMsg );
  EndIf;
EndIf;

# Validate if alias exists in dimension
If ( pAlias @<> '' );
  If ( DimIx ( sDimAttr, pAlias ) = 0 );
    sMsg = 'The Alias does not exist in the dimension';
    ItemReject ( sMsg );
  EndIf;
EndIf;

# Validate if attribute is an alias
If ( pAlias @<> '' );
  If ( DType ( sDimAttr, pAlias ) @<> 'AA' );
    sMsg = 'The Alias entered is not an Alias in the dimension';
    ItemReject ( sMsg );
  EndIf;
EndIf;


## Destroy subset if it exists or if it has been converted to static
If ( SubsetExists ( pDim, pSub ) =1 );
  SubsetDestroy ( pDim, pSub );
EndIf;


## Build subset
sMDX = '{ TM1FilterByLevel ( { TM1DrillDownMember ( { ['| pDim |'].['| pConsolElement |']},ALL,RECURSIVE)}, '| NumberToString ( pLevel ) |')}';
SubsetCreateByMDX ( pSub, sMDX );


## Set Alias
If ( pAlias @<> '' );
  SubsetAliasSet ( pDim, pSub, pAlias );
EndIf;
573,1

574,1

575,2
#****Begin: Generated Statements***
#****End: Generated Statements****
576,_ParameterConstraints=e30=
930,0
638,1
804,0
1217,0
900,
901,
902,
938,0
937,
936,
935,
934,
932,0
933,0
903,
906,
929,
907,
908,
904,0
905,0
909,0
911,
912,
913,
914,
915,
916,
917,0
918,1
919,0
920,50000
921,""
922,""
923,0
924,""
925,""
926,""
927,""
